var cqrLog = {
    logLevel: 3, 
                // Levels are
                // 0 - silent except errors;
                // 1 - warn (warnings & errors);
                // 2 - info (general messages)
                // 3 - debug (all process messages)
    logDevice: 'jsConsole',
                 // Devices are
                 // jsConsole - FF JS console
                 // jConsole - Java console
                 // dump - FF's dump()
    warnings: 0,
    errors: 0,
    jsConsoleService:  Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService),
    
    init: function Logger_Init(){
        cqrLog.setLevel(cqrEnv.LogLevel);
        cqrLog.debug('Logging loaded ');
    },
    
    setLevel: function(val){
        cqrLog.logLevel = val;
        cqrLog.info('Log level set to ' + cqrLog.logLevel);
    },
    
    stat: function(){
        return cqrLog.errors + ' errors, ' + cqrLog.warnings + ' warnings so far';
    },

    out: function(strMsg){
        if (cqrLog.logDevice == 'jsConsole') {
            cqrLog.jsConsoleService.logStringMessage(strMsg);
            return;
        } else if (cqrLog.logDevice == 'dump') {
            dump(strMsg);
            return;
        } else {
            //not implemented
        }
    },
    
    err: function(strMsg, objErr){
        cqrLog.errors += 1;
        var caller = (cqrLog.err.caller ? cqrLog.err.caller.name : '');
        message = 'ConQuery ERROR: ' + caller + ' > ' + strMsg + ":\n"+objErr;
        cqrLog.out(message)
    },

    warn: function(strMsg){
        cqrLog.warnings += 1;
        if (cqrLog.logLevel < 1) return;
        var caller = (cqrLog.warn.caller ? cqrLog.warn.caller.name : 'Root');
        cqrLog.out('ConQuery WARN: ' + caller + '> ' + strMsg)
    },

    info: function(strMsg){
        if (cqrLog.logLevel < 2) return;
        var caller = (cqrLog.info.caller ? cqrLog.info.caller.name : 'Root');
        cqrLog.out('ConQuery INFO: ' + caller + '> ' + strMsg)
    },

    debug: function(strMsg){
        if (cqrLog.logLevel < 3) return;
        var caller = (cqrLog.debug.caller ? cqrLog.debug.caller.name : 'Root');
        cqrLog.out('ConQuery DEBUG: ' + caller + '> ' + strMsg)
    }
}

var cqrTimer = {
    timers: new Array(),
    
    start: function(timerId){
        var ms = new Date();
        cqrTimer.timers[timerId] = ms;
    },
    
    stop: function(timerId){
        if (cqrTimer.timers[timerId]) {
            var ms = new Date()-cqrTimer.timers[timerId];
            return(String(ms/60).substr(0,4)+' seconds');
        } else {
            return null;
        }
    }
}

var cqrTools = {
    trim: function(strStr){
        s = strStr.replace(/^\s+/, '');
        return s.replace(/\s+$/, '');
    },
}

cqrLog.init();
cqrTimer.start('load');
